/*=======================================

	Memory leak detection header file

=======================================*/

//#define LEAKDBG

#ifdef LEAKDBG
	#define _CRTDBG_MAP_ALLOC
		#include <stdlib.h>
		#include <crtdbg.h>
#endif

#ifdef LEAKDBG
  #define meMalloc(s)       _malloc_dbg(s, _NORMAL_BLOCK, __FILE__, __LINE__)
  #define meCalloc(c, s)    _calloc_dbg(c, s, _NORMAL_BLOCK, __FILE__, __LINE__)
  #define meRealloc(p, s)   _realloc_dbg(p, s, _NORMAL_BLOCK, __FILE__, __LINE__)
  #define meExpand(p, s)    _expand_dbg(p, s, _NORMAL_BLOCK, __FILE__, __LINE__)
  #define meFree(p)         _free_dbg(p, _NORMAL_BLOCK)
  #define meMemSize(p)      _msize_dbg(p, _NORMAL_BLOCK)

  #define meNew new(_NORMAL_BLOCK, __FILE__, __LINE__)
  #define meDelete delete

  // Set to dump leaks at the program exit.
  #define meInitMemoryCheck() \
    _CrtSetDbgFlag( _CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF)

#else
  #define meMalloc malloc
  #define meCalloc calloc
  #define meRealloc realloc
  #define meExpand _expand
  #define meFree free
  #define meMemSize _msize

  #define meNew new
  #define meDelete delete

  #define meInitMemoryCheck()

#endif